
.386
.model flat,stdcall
option casemap:none

include    						\masm32\include\windows.inc
include    						\masm32\include\user32.inc
include    						\masm32\include\kernel32.inc
include    						\masm32\include\gdi32.inc
includelib 						\masm32\lib\user32.lib
includelib 						\masm32\lib\kernel32.lib
includelib 						\masm32\lib\gdi32.lib
 
.data
_class								db "CustomCaption_cwx",0
about									db "by kero <geocities.com/xmemor>, v.2005-12-12",0
_user32								db "user32",0
_DrawCaptionTempA			db "DrawCaptionTempA",0
_font									db "MS Sans Serif",0

.data?
hinst									HINSTANCE ?
hicon									HICON ?
hfont									HFONT ?
hdc										HDC ?
hobj									dd ?
adr_DrawCaptionTempA	dd ?
ncAct									dd ?
ncActTB								dd ?
rt1										RECT <>
rt2										RECT <>
buff									db MAX_PATH+1 dup(?)

.code

;######################################################################################################

NcPaint proc uses ebx esi edi hWnd:HWND

		invoke GetWindowDC, hWnd
		mov hdc,eax
		invoke GetClientRect, hWnd, addr rt2

		invoke GetSystemMetrics,SM_CXSIZE 			; Width of a button in a window's caption or title bar, in pixels 
		mov esi,eax 

		mov edi,eax
		add edi,eax
		add edi,eax ;  => 3 buttons

		invoke GetSystemMetrics,SM_CXBORDER 		; Width of a window border, in pixels
		add esi,eax 
		invoke GetSystemMetrics,SM_CXFRAME 			; width of the horizontal border
;		mov xf, eax 
		add esi,eax 
		mov eax,esi 
		add eax,1
		mov rt1.left,eax 

		invoke GetSystemMetrics,SM_CYFRAME 			; height of the vertical border
		mov ebx,eax 
		mov rt1.top,eax 

		mov eax,rt2.right 
		sub eax,rt2.left 
		mov rt1.right,eax 

		invoke GetSystemMetrics,SM_CYSIZE 			;	height of a button in a window's caption or title bar, in pixels 
		add eax,ebx
		mov rt1.bottom,eax

;SM_CYCAPTION

;		sub rt1.right,50
		sub rt1.right,edi
		add rt1.right,6

;		invoke SetBkMode,hdc,TRANSPARENT
		invoke SetTextColor,hdc,00F0F00Fh

		invoke CreateFont,16,16,0,0,900,0,0,0,OEM_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_SCRIPT,addr _font

;		invoke CreateFont,24,\													; nHeight								// height of font
;											16,\													; nWidth								// average character width
;											0,\														; nEscapement,          // angle of escapement
;											0,\														; nOrientation,         // base-line orientation angle
;											400,\													; fnWeight							// font weight
;											0,\														; fdwItalic,           	// italic attribute option
;											0,\														; fdwUnderline,        	// underline attribute option
;											0,\														; fdwStrikeOut,        	// strikeout attribute option
;											OEM_CHARSET,\									; fdwCharSet,          	// character set identifier
;											OUT_DEFAULT_PRECIS,\					; fdwOutputPrecision,  	// output precision
;											CLIP_DEFAULT_PRECIS,\					; fdwClipPrecision,    	// clipping precision
;											DEFAULT_QUALITY,\							; fdwQuality,          	// output quality
;											DEFAULT_PITCH or FF_SCRIPT,\	; fdwPitchAndFamily,   	// pitch and family
;											ADDR _font									  ; lpszFace           		// typeface name

		mov hfont,eax 
		invoke SelectObject,hdc,hfont
		mov hobj,eax

		invoke SendMessage,hWnd,WM_GETTEXT,MAX_PATH+1,addr buff

;		invoke DrawCaption,hWnd,hdc,addr rt1,ncAct ;


;;		invoke DrawCaptionTempA,   0,hdc,addr rt1,hfont,hicon,addr buff,ncAct ; DC_SMALLCAP or DC_BUTTONS
;
		push ncAct
		push 0 ; offset buff           ; 0
		push 0 ;hicon
		push hfont
		push offset rt1
		push hdc
		push 0 ; hWnd
		call adr_DrawCaptionTempA

		invoke DrawText,hdc,addr buff,-1,addr rt1,0

		invoke SelectObject,hdc,hobj
		invoke DeleteObject,hfont
		invoke ReleaseDC,hWnd,hdc
		ret
NcPaint endp

;######################################################################################################

WndProc proc uses ebx esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov eax,uMsg

	.if eax==WM_DESTROY
		invoke PostQuitMessage,0

;	.elseif eax==WM_CREATE

;	.elseif eax==WM_PAINT
;		invoke NcPaint,hWnd
;		invoke DefWindowProc,hWnd,uMsg,wParam,lParam

	.elseif eax==WM_NCACTIVATE
		.if wParam==0
			mov ncAct,DC_TEXT or DC_GRADIENT ; DC_ICON or DC_BUTTONS or 
			mov ncActTB,DC_ICON or DC_TEXT or DC_INBUTTON or DC_BUTTONS ; 
		.else
			mov ncAct,DC_TEXT or DC_GRADIENT or DC_ACTIVE ; DC_ICON or DC_BUTTONS or 
			mov ncActTB,DC_ICON or DC_TEXT or DC_INBUTTON or DC_ACTIVE or DC_BUTTONS ; 
		.endif
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		invoke NcPaint,hWnd

	.elseif eax==WM_NCPAINT
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		invoke NcPaint,hWnd

	.elseif eax==WM_SETTEXT
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		invoke NcPaint,hWnd

	.elseif eax==WM_GETICON ; || eax==WM_SYSCOMMAND
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		invoke NcPaint,hWnd

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

;######################################################################################################

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	local wc:WNDCLASSEX
	local msg:MSG
	local hWnd:HWND
	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,0
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov eax, hInst
	mov wc.hInstance,eax
	mov wc.hbrBackground,COLOR_WINDOW
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset _class
	invoke LoadIcon,0,IDI_EXCLAMATION ; IDI_APPLICATION
	mov wc.hIcon,eax
	mov wc.hIconSm,eax

	mov hicon,eax

	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,WS_EX_TOPMOST,\
												offset _class,offset _class,\
												WS_POPUP or WS_CAPTION or WS_SYSMENU or WS_VISIBLE or WS_THICKFRAME or WS_MINIMIZEBOX,\
												15,216,457,191,0,0,hInst,0
	mov hWnd,eax
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

;######################################################################################################

start:
	invoke GetModuleHandle,addr _user32
	invoke GetProcAddress,eax,addr _DrawCaptionTempA
	mov adr_DrawCaptionTempA,eax

	invoke GetModuleHandle,0
	mov hinst,eax	
	invoke WinMain,eax,0,0,SW_SHOWDEFAULT
	invoke ExitProcess,eax
end start

;######################################################################################################
